<template lang="">
  <navbar></navbar>
  <h1 class="text-center mt-12 text-4xl font-bold">Registrar Asistencia</h1>

  <div class="bg-secondary m-auto w-96 rounded-2xl">
    <h1 class="text-center mt-12 text-4xl font-bold">{{ this.date }}</h1>
  </div>
  <div class="text-sm breadcrumbs ml-12 mt-10">
    <ul>
      <li>
        <a
          @click="
            $router.push({
              path: menuAsistenciaURL,
            })
          "
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            class="w-4 h-4 mr-2 stroke-current"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"
            ></path>
          </svg>
          Asistencia
        </a>
      </li>
      <li>
        <a
          @click="
            $router.push({
              path: seleccionarCursoURL,
            })
          "
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            class="w-4 h-4 mr-2 stroke-current"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"
            ></path>
          </svg>
          Seleccionar Curso
        </a>
      </li>
      <li>
        <a
          @click="
            $router.push({
              path: registrarAsistenciaURL,
              query:{curso_id:this.$route.query.curso_id}
            })
          "
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 24 24"
            class="w-4 h-4 mr-2 stroke-current"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M3 7v10a2 2 0 002 2h14a2 2 0 002-2V9a2 2 0 00-2-2h-6l-2-2H5a2 2 0 00-2 2z"
            ></path>
          </svg>
          Registrar Asistencia
        </a>
      </li>
    </ul>
  </div>
  <div
    class="bg-white ml-24 mr-24 mt-12 mb-2 border-2 border-black rounded-3xl"
  >
    <div class="overflow-auto">
      <table class="table w-auto h-auto m-auto mt-12 overflow-x-scroll mb-12">
        <thead
          class="flex flex-col items-center justify-between overflow-y-hidden w-full"
        >
          <tr class="">
            <th class="w-96 bg-white text-center font-bold text-2xl">Nombre</th>
            <th class="w-72 bg-white"></th>

            <th class="w-96 bg-white text-end font-bold text-2xl">
              Asistencia
            </th>
          </tr>
        </thead>
        <div
          class="bg-grey-light items-center justify-between overflow-y-scroll w-full h-96"
        >
          <tbody
            v-if="alumnos.length != 0"
            v-for="alumno in alumnos"
            :key="alumno.nombre"
          >
            <tr v-if="alumno.id != 0">
              <td class="w-96 bg-white text-center text-xl font-semibold">
                {{ alumno.nombre }}
              </td>

              <td class="w-72 bg-white"></td>
              <td
                class="w-96 bg-white text-xl text-end font-semibold rounded-none"
              ></td>
              <td class="w-20 bg-white"></td>
              <div class="inline-flex">
                <button
                  type="button "
                  class="w-20 hover hover:bg-warning bg-accent mr-3 rounded-2xl"
                  @click="
                    show(alumno),
                      cambiarEstadoTrue(),
                      registrarAsistenciaTrue(alumno.usuId)
                  "
                >
                  SI
                </button>
                <button
                  type="button"
                  class="w-20 hover hover:bg-warning bg-error ml-3 rounded-2xl"
                  @click="
                    show(alumno),
                      cambiarEstadoFalse(),
                      registrarAsistenciaFalse(alumno.usuId)
                  "
                >
                  NO
                </button>
              </div>
            </tr>
            <div
              v-else
              class="mt-9 m-auto bg-success text-center items-center content-center"
            >
              <h1 class="m-auto">REGISTRO GUARDADO</h1>
            </div>
          </tbody>
          <div v-else class="text-center">
            <h1 class="text-2xl mt-24 font-bold">
              No se encuentran alumnos registrados en el curso
            </h1>
          </div>
        </div>
      </table>
    </div>
  </div>
  <div class="flex-col text-center">
    <button
      type="submit"
      @click="$router.push({ path: 'SeleccionarMateria' })"
      class="btn btn-primary inline-flex mt-12 mr-12 mb-12 justify-center align-middle text-xl rounded-full font-semibold border-2 border-black py-2 px-4 shadow-sm hover:bg-purple-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 h-20 w-44 f"
    >
      Volver
    </button>
    <button
      v-if="alumnos.length != 0"
      type="submit"
      @click="$router.push({path:'/RegistroExitoso', query:{curso_id:this.$route.query.curso_id}})"
      class="btn btn-primary inline-flex mt-12 mb-12 a justify-center align-middle text-xl font-semibold rounded-full border-2 border-black py-2 px-4 shadow-sm hover:bg-purple-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 h-20 w-44 f"
    >
      Registrar
    </button>
  </div>
</template>

<script>
import axios from "axios";
import { ref } from "vue";

import navbar from '../../components/Navbar.vue'
export default {
  components: { navbar },
  data() {
    const show = ref(true);
    var today = new Date();
    return {
      nro1: 5,
      nro2: 6,
      registrarAsistenciaURL:"",
      seleccionarCursoURL:"",
      menuAsistenciaURL:"",
      boolean: true,
      asistencia: {
        fechAsistencia: today,
        estConfirmar: "",
      },
      alumnos: [],
      date:
        today.getFullYear() +
        "-" +
        (today.getMonth() + 1) +
        "-" +
        today.getDate(),
    };
  },

  mounted() {
    const peticion = this.$route.query.curso_id;
    var vacio = 1;
    axios
      .get("asistencia/alumnosCurso/" + peticion, {
     
      })
      .then((response) => {
        /*   this.msg=response.data
                console.log(response.data)
                vue.tareas = response.data;
              this.id=response.data[0].tareaId;

              this.descripcion=response.data[0].nombreTarea.substring(0,25);
           
              this.fecha = response.data[0].fechTermino.substring(0, 10);

              this.hora = response.data[0].fechTermino.substring(11,16);
              this.fechaEntrega = this.fecha + this.hora;
                 */

        console.log(response.data);

        this.alumnos = response.data;
      });
      axios
        .get("cuentas/usuario", {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((response) => {

          if (response.data.rol == "DOCENTE") {
            this.menuAsistenciaURL=
              "/MainAsistenciaDocente";
            this.seleccionarCursoURL=
              "/SeleccionarMateria";
            this.registrarAsistenciaURL=
              "/RegistrarAsistencia"
          } else if (response.data.rol == "ALUMNO") {
            this.menuAsistenciaURL=
              "/MainAsistenciaEstudiante"
          }

        });
  },

  methods: {
    registrarAsistenciaTrue(idAl) {
      this.asistencia.estConfirmar=true;
      axios
        .post("asistencia/registrarAsistencia/" + idAl, this.asistencia, {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((response) => {
          console.log("Se ha registrado asistencia del alumno " + idAl);
        });
    },
    registrarAsistenciaFalse(idAl) {
      this.asistencia.estConfirmar=false;
      axios
        .post("asistencia/registrarAsistencia/" + idAl, this.asistencia, {
          headers: {
            Authorization: localStorage.getItem("auth"),
          },
        })
        .then((response) => {
          console.log("Se ha registrado asistencia del alumno " + idAl);
        });
    },
    cambiarEstadoFalse() {
      this.estConfirmar = false;
    },
    cambiarEstadoTrue() {
      this.estConfirmar = true;
    },
    show(alumno) {
      alumno.id = 0;
    },
    mostrar(alumno) {
      console.log(alumno);
    },
  },
};
</script>
<style lang=""></style>
